import numpy as np


def Phi(U, param):
    """Function evaluation of the nonlinear function in the objective based on elementary operations
    """

    N  = np.size(U)
    x0 = param['x0']
    h  = param['T'] / N
    q  = param['q']

    # NOTE: dtype might be complex in case of imaginary trick,
    # so must be specified.
    X = np.zeros(N+1, dtype=U.dtype)
    X[0] = x0
    for k in range(N):
        X[k+1] = X[k] + h*((1 - X[k])*X[k] + U[k])

    f = q * X[N]**2
    return f
